#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <malloc.h>
#include <float.h>
//#include <papi.h>
#include <string.h>
#include "mpi.h"
#include "par.c"
#include <sys/time.h>
#include <sys/resource.h>

//int main(int argc, char *argv[])
int main ( argc, argv) 

//stupida aggiunta causa hydra
int argc;
     char *argv[];
//fine aggiunta
{
	FILE *pf;
	int i, j, z, cols, rows, realDim, dim, nMisure, min, max, size, rank;
//	long_long *tempi, somma, media;
long long *tempi, somma, media;
	float *a, *b, *atot, sign, ggl(), seed;
//aggiunta
	char filename[20];
	max=0;
	min=0;
	somma=0;
//int DebugWait=1;
/* const rlim_t kStackSize = 64L * 1024L * 1024L;   // min stack size = 64 Mb
    struct rlimit rl;
    int result;

    result = getrlimit(RLIMIT_STACK, &rl);
    if (result == 0)
    {
        if (rl.rlim_cur < kStackSize)
        {
            rl.rlim_cur = kStackSize;
            result = setrlimit(RLIMIT_STACK, &rl);
            if (result != 0)
            {
                fprintf(stderr, "setrlimit returned result = %d\n", result);
            }
        }
    }	
*/
	MPI_Init(&argc, &argv);
	MPI_Comm_size(MPI_COMM_WORLD, &size);
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
//while(DebugWait);
	/*legge quante misurazioni fare*/
//	sscanf(argv[2], "%d", &nMisure);
nMisure=10;
//	tempi = (long_long *) calloc(nMisure, sizeof(long_long));
	tempi = (long long *) calloc(nMisure, sizeof(long long));	
	/*legge dall'ingresso il numero di colonne*/
//	sscanf(argv[1], "%d", &realDim);
realDim = 16384;
	cols = 2;
	while (cols < realDim)
		cols *= 2;

	rows = cols / size;
	dim = 2 * rows * cols;
		
	
		
	/*lancia il programma per n Misurazioni e riceve i tempi dal master*/
	for (z = 0; z < nMisure; z++){
		if(rank != 0){
			a = (float *) malloc(2 * rows * cols * sizeof(float));
			//aggiungo b
			b = (float *) malloc(2 * cols * cols * sizeof(float));
		}
		else{ /*codice eseguito dal processo con rank == 0*/
			
			a = (float *) malloc(2 * cols * cols * sizeof(float));
			//aggiungo b
			b = (float *) malloc(2 * cols * cols * sizeof(float));
			
			seed = 331.0;
		
			/*riempie il buffer con numeri casuali e termina le matrici incomplete con lo Zero-Padding*/
			for (i = 0; i < realDim; i++) {
				for (j = 0; j < 2 * realDim; j++)
					a[2 * cols * i + j] = ggl(&seed);
				for (j = 2 * realDim; j < 2 * cols; j++)
					a[2 * cols * i + j] = 0;
			}
			for (i = realDim; i < rows; i++) {
				for (j = 0; j < 2 * cols; j++)
					a[2 * cols * i + j] = 0;
			}
		
			/*nome del file dei risultati*/
			sprintf(filename, "tempi-%d-%d.txt", size, cols);
		}
		
		sign = 1.0;
//		par(a, cols, sign, &tempi[z], MPI_COMM_WORLD, b);		
//modifica aggiunta del parametro b in coda
par(a, cols, sign, &tempi[z], MPI_COMM_WORLD, b);
	MPI_Barrier(MPI_COMM_WORLD);
		if (rank == 0){
			/*salva il tempo in un file*/
			pf = fopen(filename,"ab");
			fprintf(pf, "%d-%d-%lld\n", size, cols, tempi[z]);
			fclose(pf);
		}
//		sign = -sign;	
		free(a);
//aggiungo b
		free(b);
	}
		
	
	/*il processo con rank = 0 si occupa dei tempi raccolti*/
	if (rank == 0) {
		
		/*cerca il minimo e il massimo*/
		for(i = 1; i < nMisure; i++){
			if(tempi[i]<tempi[min])
				min=i;
			else if (tempi[i]>tempi[max])
				max=i;
		}

		/*calcola la somma dei tempi escludendo il minimo e il massimo*/
		for (i = 0; i < nMisure; i++)
			if ((i!=min)&&(i!=max))
				somma+=tempi[i];

		media = somma / (nMisure-2);

		pf = fopen("average_results.txt","ab");
		fprintf(pf, "%d-%d-%lld\n", size, cols, media);
		fclose(pf);
	
		free(tempi);
	}
	
	MPI_Finalize();
	
	return 0;
}
	
	
float ggl(ds)
float *ds;
{
/* genera numeri random tra 0 ed 1.
   Seed ds deve essere salvato tra le chiamate. 
 */

   double t,d2=0.2147483647e10;
   t   = (float) *ds;
   t   = fmod(0.16807e5*t,d2);
   *ds = (float) t;
   return((float) ((t-1.0e0)/(d2-1.0e0)));

}

int timeval_subtract(struct timeval *result, struct timeval *t2, struct timeval *t1)
{
    long int diff = (t2->tv_usec + 1000000 * t2->tv_sec) - (t1->tv_usec + 1000000 * t1->tv_sec);
    result->tv_sec = diff / 1000000;
    result->tv_usec = diff % 1000000;

    return (diff<0);
}

